# Introduction

This is a template to create **ASP.NET Core MVC / Angular**. It has 2 different versions:

1. ASP.NET Core MVC & jQuery (server rendered multi-page application).
2. ASP.NET Core & Angular (single page application).

See <a href="https://github.com/studioxsoftware/studiox/tree/master/angular" target="_blank">here</a> for details. 

## Layered Architecture

StudioX provides a layered architectural model based on **Domain Driven Design**. Provides a **SOLID** model for your application.

![NLayer Architecture](_screenshots/nlayer-architecture.png)

See <a href="https://studioxsoftware.github.io/pages/documents/NLayerArchitecture.pdf" target="_blank">NLayer Architecture</a> document for details. 
 
User Interface is based on [BSB Admin theme](https://github.com/gurayyarar/AdminBSBMaterialDesign).
 
## Sreenshots

#### Swagger

![](_screenshots/swagger.png)

#### Login Page

![](_screenshots/login.png)

#### Sample Dashboard Page
![](_screenshots/home.png)

# License

[MIT](https://opensource.org/licenses/MIT)
